package org.eclipse.corona.soa.client.util;

import java.beans.PropertyChangeEvent;
import java.net.URI;
import java.net.URISyntaxException;

//import org.eclipse.corona.container.Activator;
import org.eclipse.corona.core.CoronaException;
import org.eclipse.corona.log.CoronaLogService;
import org.eclipse.corona.soa.client.SOAPProxyProvider;
import org.eclipse.corona.soa.example.Activator;
import org.osgi.framework.BundleContext;
import org.osgi.framework.ServiceReference;

public class ServiceConnectionFactory {

	
	public static Object connect(ServiceConnectionParameters scp) throws Throwable {
		
		SOAPProxyProvider factory = getContainerProxyFactory();
		
		Class serviceProxyClass = scp.getServiceProxyClass();
		Object service = null;
		try {
			service =  factory.getProxyForClass(
					serviceProxyClass,
					new URI(scp.getServerUri() + "/sdo"), 
					scp.getServiceName(),
					scp.getServiceNameSpace(), 
					scp.getProxyHost(),
					scp.getProxyPort(),
					scp.getProxyUserName(),
					scp.getProxyUserPass());
			
		} catch (URISyntaxException e) {
			throw new CoronaException("Malformed uri " + scp.getServerUri() + ".");
		}
		
		if (service != null) {
			// just check whether connection can be established.
			//service.checkConnection();
		} else {
			throw new CoronaException(
					"Could not connect to server, or service is not available.");
		}
		
		return service;
	}

	public static SOAPProxyProvider getContainerProxyFactory() {
		
		BundleContext bundleContext = Activator.getDefault().getBundleContext();
		ServiceReference ref = bundleContext.getServiceReference("org.eclipse.corona.soa.client.SOAPProxyProvider");
		SOAPProxyProvider factory = (SOAPProxyProvider)bundleContext.getService(ref);
		
		return factory;
	}
	

}
