package org.eclipse.corona.soa.example;

import java.beans.PropertyChangeEvent;

import org.eclipse.core.runtime.Plugin;
import org.eclipse.corona.core.CoronaException;
import org.eclipse.corona.log.CoronaLogService;
import org.osgi.framework.BundleContext;

/**
 * The activator class controls the plug-in life cycle
 */
public class Activator extends Plugin {

	// The plug-in ID
	public static final String PLUGIN_ID = "org.eclipse.corona.soa.example";

	// The shared instance
	private static Activator plugin;
	private BundleContext bundleContext = null;
	/**
	 * The constructor
	 */
	public Activator() {
		plugin = this;
	}

	/*
	 * (non-Javadoc)
	 * @see org.eclipse.core.runtime.Plugins#start(org.osgi.framework.BundleContext)
	 */
	public void start(BundleContext context) throws Exception {
		super.start(context);
		bundleContext = context;
		SOAExampleClient example = new SOAExampleClient();
		example.open();
	}

	/*
	 * (non-Javadoc)
	 * @see org.eclipse.core.runtime.Plugin#stop(org.osgi.framework.BundleContext)
	 */
	public void stop(BundleContext context) throws Exception {
		plugin = null;
		super.stop(context);
	}

	/**
	 * Returns the shared instance
	 *
	 * @return the shared instance
	 */
	public static Activator getDefault() {
		return plugin;
	}

	/**
	 * Getter method for bundle context.
	 * @return BundleContext of this plugin.
	 */
	public BundleContext getBundleContext() {
		return this.bundleContext;
	}
	
}
